// The new brand of Uniform generator:

#define IA 16807
#define IM 2147483647
#define AM (1.0/IM)
#define IQ 127773
#define IR 2836
#define NTAB 32
#define NDIV (1+(IM-1)/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)



// This is the source code for the calculation of survival type data //
// Using the normal properties of Log rank test statistic			//

// Corresponding header file uni-survival.h							//
// Shuangge Ma, January 2002										//


// After deleting some comments carelessly, the code can not work any more. :(
// now the step by step work is OK.

#include "Survival.h"
#include "Normal.h"

UniSurvival::UniSurvival(){

	data_type = 'S';

	order=0;
	num_look=0;

	rule_decision = 2;

	alpha=0.0;
	beta=0.0;
	alpha_spending=new double[LIMIT_N_LOOK];
	beta_spending=new double[LIMIT_N_LOOK];
	Bi_Alpha=0.05;
	Bi_Beta=0.1;

	prop=0.0;

	inform_time=new double[LIMIT_N_LOOK];
	calender=new double[LIMIT_N_LOOK];

	alphaSpend=0;
	betaSpend=0;

	lambdaNull=0.0;
	lambdaAlter=0.0;

	entry=0.0;
	followup=0.0;

	lambdadrop=0.0;

	samplesize=0;
	
	upperbound=new double[LIMIT_N_LOOK];
	lowerbound=new double[LIMIT_N_LOOK];
	boundary=new double[2*LIMIT_N_LOOK];

	ctrl_ind = new int[8];
}




int UniSurvival::getLooksimul()
{
	looksimul = (int)num_simul/num_look;
	return looksimul;
}



int UniSurvival::Choice()
{
	int selection;

	selection=2;
	int size;
	if(selection==1)
		size=SizeCalculation();
	else if(selection==2)
		SizeGaussian();

	return size;

}




// The initial sample size estimate
int UniSurvival::IniSizeEstimate()
{
	// in the above settings, the initial sample size estimate is by RGS method
	int samplesize;
	
	double zalpha, zbeta, delta;
	double EPc, EPe;
	double phic, phie;

	zalpha=normalscore(alpha, 2000);
	zbeta=normalscore(beta, 2000);	// normalscore is a function in EndNormal.cpp

//	cout<<"zalpha"<<"\t"<<zalpha<<endl;
//	cout<<"zbeta"<<"\t"<<zbeta<<endl;
	if(lambdaNull > lambdaAlter )
		delta=lambdaNull/lambdaAlter;
	if(lambdaNull < lambdaAlter )
		delta=lambdaAlter/lambdaNull;

//	cout<<"delta"<<"\t"<<delta<<endl;

	phic=lambdaNull + lambdadrop;
	phie=lambdaAlter + lambdadrop;

	EPc=1-exp(-phic*followup)*(1-exp(-phic*entry))/(phic*entry);
	EPe=1-exp(-phie*followup)*(1-exp(-phie*entry))/(phie*entry);

	samplesize= (int) ((zalpha+zbeta)/(log(delta)))*((zalpha+zbeta)/(log(delta)))*(1/EPc+ 1/EPe);

	return samplesize;

}




//	Search for the minimal sample size for sequencial data
//  After getting the correct sample size, we will give it directly to the samplesize

int  UniSurvival ::SizeCalculation()
{
	int i, j, k;

	int simul1=2000;
	// we need to calculate or input this number somewhere(@@)	

	int con1;
	//copy from the Normal case.
	int trysize;
	trysize=IniSizeEstimate();

	double *structure;
	structure=new double[2*num_look+2*num_look*2*num_look];
	structure=ParameterEstimate(10000,200);

	// we check the return structure:
	cout<<"we check the return structure"<<endl;
	for(i=0; i<2*num_look+2*num_look*2*num_look; i++)
		cout<<structure[i]<<"\t";
	cin>>con1;

	double *cov1;
	cov1=new double[2*num_look*2*num_look];

	for(i=0; i<2*num_look*2*num_look; i++)
		cov1[i]=structure[i+2*num_look];


	//first check the corr (the covariance structure):

	double *work1;
	work1=new double[2*num_look*simul1];
	work1=NormalGenerator(2*num_look, simul1, cov1);

	double *workNull1, *workAlter1;
	workNull1=new double[num_look*simul1];
	workAlter1=new double[num_look*simul1];

	//seperate Null and Alter:
	for(i=0; i<simul1; i++) {
		for(j=0; j<num_look; j++) {
			workNull1[i*num_look+j]=work1[i*2*num_look+j];
			workAlter1[i*num_look+j]=work1[i*2*num_look+num_look+j];
		}
	}


	// The check of Null and Alter Structure separately:
	double *NullStructure, *AlterStructure;
	NullStructure=new double[2*num_look+num_look*num_look];
	AlterStructure=new double[2*num_look+num_look*num_look];

	NullStructure=NormalCheck(num_look, simul1, workNull1);
	AlterStructure=NormalCheck(num_look, simul1, workAlter1);
	

	// now we will add the non-central parameter for Alter:
	// we now have workNull1 & workAlter1
	for(i=0; i<num_look; i++) {
		for(j=0; j<simul1; j++) {
			workAlter1[j*num_look+i]=workAlter1[j*num_look+i]+structure[i+num_look];
		}
	}

	double *boundary, *upperbound, *lowerbound;
	boundary=new double[2*num_look];
	upperbound=new double[num_look];
	lowerbound=new double[num_look];

	boundary=BoundCalculation(simul1, workNull1, workAlter1);

	return trysize;

}






// We estimate the Normal structure of the logrank test statistics.

//simultimes:	how many groups we simulate
//numeach:		for each test statistic, how many events we simulate

//we will get (simultimes) test statistic, to get each test statistic, we simulate (numeach) events
double *UniSurvival::ParameterEstimate(int simultimes, int numeach)
{
	double *structure;
	double *mean1, *var1, *corr1;
	structure=new double[2*num_look+2*num_look*2*num_look];
	// the structure will look like:
	// meanA1, meanA2, covariance.
	// covariance: Null(look1), Null(look2),....Alter(look1), Alter(look2).....
	mean1=new double[num_look];
	var1=new double[num_look];
	corr1=new double[num_look*num_look];


	double *survivalTimeNull;
	double *survivalTimeNull_1;
	double *survivalTimeAlter;
	survivalTimeNull=new double[numeach];
	survivalTimeNull_1=new double[numeach];
	survivalTimeAlter=new double[numeach];	// survival time under Null and Alternative


	double *entryNull, *entryNull_1,*entryAlter;		// Patients entry time
	entryNull=new double[numeach];
	entryNull_1=new double[numeach];
	entryAlter=new double[numeach];


	double *eventTimeNull, *eventTimeNull_1, *eventTimeAlter;
	eventTimeNull=new double[numeach];
	eventTimeNull_1=new double[numeach];
	eventTimeAlter=new double[numeach];


	double *combineNull, *combineAlter; // combine palcebo and trt. for Null and Alter.
	combineNull=new double[2*numeach];
	combineAlter=new double[2*numeach];


	double *testStatNull, *testStatAlter;
	double *testStatComp;
	testStatNull=new double[simultimes*num_look];
	testStatAlter=new double[simultimes*num_look];
	testStatComp=new double[simultimes*num_look];


	int * indicatorNull, * indicatorAlter, *indicatorNull_1;
	int totaleventNull=0, totaleventNull_1=0, totaleventAlter=0;
	indicatorNull= new int[numeach];
	indicatorNull_1=new int[numeach];
	indicatorAlter= new int[numeach];


	double *lookTimeNull, *lookTimeAlter;	// The look time under Null and Alter;
	lookTimeNull=new double[num_look];
	lookTimeAlter=new double[num_look];


	
	int i, j, k, l, m, n, o, q;

	int ii;

	int con1;

	double *check1, * check2;
	check1=new double[numeach];
	check2=new double[numeach];

	double checkmean=0;
	double checkvar=0;



	// calculate test statistic under Null and Alter
	for(l=0; l<simultimes; l++){
		
		survivalTimeNull=ExpGenerator(numeach, lambdaNull);
	
		survivalTimeNull_1=ExpGenerator(numeach, lambdaNull);
		
		survivalTimeAlter=ExpGenerator(numeach, lambdaAlter);

		// we new check survivalTimeNull;
		checkmean=0; checkvar=0;
		for(ii=0; ii<numeach; ii++)
			checkmean=checkmean+survivalTimeNull[ii];
		checkmean=checkmean/numeach;
		for(ii=0; ii<numeach; ii++)
			checkvar=checkvar+(survivalTimeNull[ii]-checkmean)*(survivalTimeNull[ii]-checkmean);
		checkvar=checkvar/numeach;




		checkmean=0; checkvar=0;
		for(ii=0; ii<numeach; ii++)
			checkmean=checkmean+survivalTimeAlter[ii];
		checkmean=checkmean/numeach;
		for(ii=0; ii<numeach; ii++)
			checkvar=checkvar+(survivalTimeAlter[ii]-checkmean)*(survivalTimeAlter[ii]-checkmean);
		checkvar=checkvar/numeach;

		int seed= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
		long *idum=new long(seed);

		srand ((unsigned)time(NULL));
		for(i=0; i<numeach; i++)
			entryNull[i]=entry*ran1(idum);

		seed= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
		
		for(i=0; i<numeach; i++)
			entryNull_1[i]=entry*ran1(idum);
		
		srand ((unsigned)time(NULL));

		seed= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;

		for(i=0; i<numeach; i++)
			entryAlter[i]=entry*ran1(idum);

		// now we check the entryNull;
		checkmean=0; checkvar=0;
		for(ii=0; ii<numeach; ii++)
			checkmean=checkmean+entryNull[ii];
		checkmean=checkmean/numeach;
		for(ii=0; ii<numeach; ii++)
			checkvar=checkvar+(entryNull[ii]-checkmean)*(entryNull[ii]-checkmean);
		checkvar=checkvar/numeach;



		// Now decide the number of event and the corresponding event time
		totaleventNull=0;
		totaleventNull_1=0;
		totaleventAlter=0;

		for(i=0; i<numeach; i++){
			if( (survivalTimeNull[i]+entryNull[i]) < (entry+followup) ) {
				totaleventNull=totaleventNull+1;
				indicatorNull[i]=0;
				eventTimeNull[i]=survivalTimeNull[i]+entryNull[i];
			}
			else {
				indicatorNull[i]=1;
				eventTimeNull[i]=entry+followup;
			}


			if( (survivalTimeNull_1[i]+entryNull_1[i]) < (entry+followup) ) {
				totaleventNull_1=totaleventNull_1+1;
				indicatorNull_1[i]=0;
				eventTimeNull_1[i]=survivalTimeNull_1[i]+entryNull_1[i];
			}
			else {
				indicatorNull_1[i]=1;
				eventTimeNull_1[i]=entry+followup;
			}


			if( (survivalTimeAlter[i]+entryAlter[i]) < (entry+followup) ) {
				totaleventAlter=totaleventAlter+1;
				indicatorAlter[i]=0;
				eventTimeAlter[i]=survivalTimeAlter[i]+entryAlter[i];
			}
			else {
				indicatorAlter[i]=1;
				eventTimeAlter[i]=entry+followup;
			}
		}	// Now have counted the total number of events in Null and Alternative

		int countEventNull, countEventAlter;
		countEventNull=totaleventNull+totaleventNull_1;
		countEventAlter=totaleventNull+totaleventAlter;


		for(o=0; o<numeach; o++){
			combineNull[o]=eventTimeNull[o];
			combineAlter[o]=eventTimeNull[o];
			combineNull[o+numeach]=eventTimeNull_1[o];
			combineAlter[o+numeach]=eventTimeAlter[o];
		}

		mySort(combineNull, 2*numeach);
		mySort(combineAlter, 2*numeach);


		// check for combined Null and combined Alter
		double *inform_temp;
		inform_temp= new double[2*num_look];

		for(ii=0; ii<num_look; ii++)
			inform_temp[ii]=1.0*inform_time[ii];
		for(ii=0; ii<num_look; ii++)
			inform_temp[ii]=inform_temp[ii]/inform_temp[num_look-1];
		
		for(q=0; q<num_look; q++) {
			int temp_i = (int) countEventNull*inform_temp[q];
			if(temp_i==2*numeach)
				temp_i=temp_i-1;
			lookTimeNull[q] = combineNull[ temp_i ];
			int temp_j = (int) countEventNull*inform_temp[q];
			if(temp_j==2*numeach)
				temp_j=temp_j-1;
			lookTimeAlter[q] = combineAlter[ temp_j ];
		}


		// check procedure for lookTimeNull and lookTimeAlter

		// Now we calculate the logrank test statistics:		

		int sizegroupone=0, sizegrouptwo=0, sizegroupthree=0, sizegroupfour=0;

		double *workTimeNull;
		double *workTimeNull_1;
		double *workTimeAlter;
		int *workIndicatorNull;
		int *workIndicatorNull_1;
		int *workIndicatorAlter;
		double *workTimeNew;	// when we use data from Null working with Alter
		int *workIndicatorNew;		// corresponding indicator

		workTimeNull=new double[numeach];
		workTimeNull_1=new double[numeach];
		workTimeAlter=new double[numeach];
		workTimeNew=new double[numeach];

		workIndicatorNull=new int[numeach];
		workIndicatorNull_1=new int[numeach];
		workIndicatorAlter=new int[numeach];
		workIndicatorNew=new int[numeach];

		double tem1=0, tem2=0;

		for(q=0; q<num_look; q++) {
			sizegroupone=0;		//Null
			sizegrouptwo=0;		//Null_1
			
			sizegroupthree=0;	// Null (when working with Alter)
			sizegroupfour=0;	// Alter

			
			for(o=0; o<numeach; o++) {

				//for the first logrank test statistic:
				//for the Null:
				if(entryNull[o]<lookTimeNull[q]){
					tem1=entryNull[o]+survivalTimeNull[o];
					if(tem1<=lookTimeNull[q]) {
						workTimeNull[sizegroupone]=tem1;
						workIndicatorNull[sizegroupone]=0;
						sizegroupone=sizegroupone+1;
					}
				}
				mySort(workTimeNull, sizegroupone);
				//for the Null_1;
				if(entryNull_1[o]<lookTimeNull[q]){
					tem1=entryNull_1[o]+survivalTimeNull_1[o];
					if(tem1<=lookTimeNull[q]) {
						workTimeNull_1[sizegrouptwo]=tem1;
						workIndicatorNull_1[sizegrouptwo]=0;
						sizegrouptwo=sizegrouptwo+1;
					}
				}
				mySort(workTimeNull_1, sizegrouptwo);
			
				//for the second logrank test statistic:
				//for the Null:
				if(entryNull[o]<lookTimeAlter[q]){
					tem1=entryNull[o]+survivalTimeNull[o];
					if(tem1<=lookTimeAlter[q]) {
						workTimeNew[sizegroupthree]=tem1;
						workIndicatorNew[sizegroupthree]=0;
						sizegroupthree=sizegroupthree+1;
					}
				}
				mySort(workTimeNew, sizegroupthree);

				if(entryAlter[o]<lookTimeAlter[q]){
					tem1=entryAlter[o]+survivalTimeAlter[o];
					if(tem1<=lookTimeAlter[q]) {
						workTimeAlter[sizegroupthree]=tem1;
						workIndicatorAlter[sizegroupfour]=0;
						sizegroupfour=sizegroupfour+1;
					}
				}
				mySort(workTimeAlter, sizegroupfour);
			}

			// check of the following: 
			
			testStatNull[l*num_look + q]=LogRankA( workTimeNull, workIndicatorNull, sizegroupone, 
				workTimeNull_1, workIndicatorNull_1, sizegrouptwo, totaleventNull, totaleventNull_1);

			testStatComp[l*num_look + q]=LogRankA( workTimeNull_1, workIndicatorNull_1, sizegrouptwo, 
				workTimeNull, workIndicatorNull, sizegroupone, numeach, numeach);
			
			testStatAlter[l*num_look+q]=LogRankA(workTimeNew, workIndicatorNew, sizegroupthree, 
				workTimeAlter, workIndicatorAlter, sizegroupfour, totaleventNull, totaleventAlter);
			cout<<"testStatAlter"<<"\t"<<testStatAlter[l*num_look+q]<<endl;
			
		}	// for each look;

	}	// loop for looksimul times.


	// The check procedure of the logrank test statistic
	int cii, cjj, ckk;
	double lmean, lvar;
	double *meanA1, *meanA2;
	double *varA1, *varA2;
	double *covarianceA1;

	meanA1=new double[num_look];
	meanA2=new double[num_look];
	varA1=new double[num_look];
	varA2=new double[num_look];
	covarianceA1=new double[2*num_look*2*num_look];
	
//	cout<<"Check of the mean and var for the logrank: Null"<<endl;
	//now check the testStatNull:
	for(cii=0; cii<num_look; cii++) {
		lmean=0;
		lvar=0;
		for(cjj=0; cjj<simultimes; cjj++) {
			lmean=lmean+testStatNull[cjj*num_look+cii];
		}
		lmean=lmean/simultimes;
		meanA1[cii]=lmean;
		for(cjj=0; cjj<simultimes; cjj++) {
			lvar=lvar+(testStatNull[cjj*num_look+cii]-lmean)*(testStatNull[cjj*num_look+cii]-lmean);
		}
		lvar=lvar/simultimes;
		varA1[cii]=lvar;
	}


	// now we calculate the corr structure:

	double *checkcorr;
	double temp1;
	checkcorr=new double[num_look*num_look];
	for(cii=0; cii<num_look; cii++) {
		for(cjj=0; cjj<num_look; cjj++) {
			temp1=0;
			for(ckk=0; ckk<simultimes; ckk++) {
				temp1=temp1+(testStatComp[ckk*num_look+cii]-meanA1[cii])*(testStatComp[ckk*num_look+cjj]-meanA1[cjj]);
			}
			checkcorr[cii*num_look+cjj]=temp1/simultimes;
			covarianceA1[cii*2*num_look+cjj]=temp1/simultimes;
			checkcorr[cii*num_look+cjj]=checkcorr[cii*num_look+cjj]/sqrt(varA1[cii]*varA1[cjj]);
		}
	}


	//new check for the testStatAlter:
	for(cii=0; cii<num_look; cii++) {
		lmean=0;
		lvar=0;
		for(cjj=0; cjj<simultimes; cjj++) {
			lmean=lmean+testStatAlter[cjj*num_look+cii];
		}
		lmean=lmean/simultimes;
		meanA2[cii]=lmean;
		for(cjj=0; cjj<simultimes; cjj++) {
			lvar=lvar+(testStatAlter[cjj*num_look+cii]-lmean)*(testStatAlter[cjj*num_look+cii]-lmean);
		}
		lvar=lvar/simultimes;
		varA2[cii]=lvar;
	}

	for(cii=0; cii<num_look; cii++) {
		for(cjj=0; cjj<num_look; cjj++) {
			temp1=0;
			for(ckk=0; ckk<simultimes; ckk++) {
				temp1=temp1+(testStatAlter[ckk*num_look+cii]-meanA2[cii])*(testStatAlter[ckk*num_look+cjj]-meanA2[cjj]);
			}
			checkcorr[cii*num_look+cjj]=temp1/simultimes;
			covarianceA1[(cii+num_look)*2*num_look+cjj+num_look]=temp1/simultimes;
			checkcorr[cii*num_look+cjj]=checkcorr[cii*num_look+cjj]/sqrt(varA2[cii]*varA2[cjj]);
		}
	}

	//check the corr between Null and Alter:
	for(cii=0; cii<num_look; cii++) {
		for(cjj=0; cjj<num_look; cjj++) {
			temp1=0;
			for(ckk=0; ckk<simultimes; ckk++) {
				temp1=temp1+(testStatNull[ckk*num_look+cii]-meanA1[cii])*(testStatAlter[ckk*num_look+cjj]-meanA2[cjj]);
			}
			checkcorr[cii*num_look+cjj]=temp1/simultimes;
			covarianceA1[cii*2*num_look+num_look+cjj]=temp1/simultimes;
			covarianceA1[(cii+num_look)*2*num_look+cjj]=temp1/simultimes;
			checkcorr[cii*num_look+cjj]=checkcorr[cii*num_look+cjj]/sqrt(varA1[cii]*varA2[cjj]);
		}
	}

	// check covarianceA1:

	// Initialize structure:
	for(cii=0; cii<num_look; cii++){
		structure[cii]=meanA1[cii];
		structure[cii+num_look]=meanA2[cii];
	}

	for(cii=0; cii<2*num_look*2*num_look; cii++)
		structure[2*num_look+cii]=covarianceA1[cii];
	

	return structure;

}

















// The calculation of critical boundary.
// Mostly copy from the Normal Case:
double * UniSurvival::BoundCalculation(int simul1, double *workNull, double *workAlter)
{	
	int i, j, k, l;
	int con1;
	double *boundary;
	double *upperbound, *lowerbound;
	
	boundary=new double[2*num_look];
	upperbound=new double[num_look];
	lowerbound=new double[num_look];




	// we substitude the first colume of workNull with a StandNormal:
	
	double *subNull;
	subNull=new double[simul1];
	subNull=Stand_Normal(simul1);

	for(i=0; i<simul1; i++)
		workNull[i*num_look+0]=subNull[i];
	// finished



	// Initialize alpha and beta:
	double *alpha3, *beta3;
	double *alpha4, *beta4;
	alpha3=new double[num_look];
	beta3=new double[num_look];
	alpha4=new double[num_look];
	beta4=new double[num_look];
	
	if(alphaSpend==1)
		alpha3=alpha_beta1(alpha);
	if(betaSpend==1)
		beta3=alpha_beta1(beta);
	if(alphaSpend==2)
		alpha3=alpha_beta2(alpha);
	if(betaSpend==2)
		beta3=alpha_beta2(beta);
	if(alphaSpend==3)
		alpha3=alpha_beta3(alpha);
	if(betaSpend==3)
		beta3=alpha_beta3(beta);

	for(i=0; i<num_look; i++){
		alpha4[i]=alpha3[i];
		beta4[i]=beta3[i];
	}

	//check alpha and beta:

	int *countAfterNull; // the number of samples left after each look.
	int *countAfterAlter;

	countAfterNull=new int[num_look];
	countAfterAlter=new int[num_look];
	countAfterNull[0]=simul1;
	countAfterAlter[0]=simul1;

	double *p0, *p1;
	p0=new double[num_look];
	p1=new double[num_look];

	for(i=0; i<num_look; i++)
		{
			p0[i]=1.0;
			p1[i]=1.0;
		}


	// The following loop copied from Normal Case:
	// Now we calculate the boundary based on the following:

	// alpha3, beta3: alpha and beta spending
	// upperbound, lowerbound: the calculated value
	// workNull and workAlter

	double *currentNull, *currentAlter;
	double *absNull, *absAlter; // The abs of Null and Alter;
	currentNull=new double[simul1];
	currentAlter=new double[simul1];
	absNull=new double[num_look*simul1];
	absAlter=new double[num_look*simul1];

	double *countNull, *countAlter;
	countNull=new double[num_look];
	countAlter=new double[num_look];

	int li, lj, lk, lm, ln, lo;
	int signNull, signAlter;
	int positionNull, positionAlter;

	for(li=0; li<2*num_look; li++)
		boundary[li]=0.0;

	for(li=0; li<num_look; li++) {
		upperbound[li]=0;
		lowerbound[li]=0;
	}

	for(li=0; li<num_look*simul1; li++){
		absNull[li]=absd(workNull[li]);
		absAlter[li]=absd(workAlter[li]);
	}

	for(li=0; li<num_look; li++){
		countNull[li]=0;
		countAlter[li]=0;
	}


	// Again, get the bound for look 0 first:

	for(li=0; li<simul1; li++){
		currentNull[li]=absNull[li*num_look+0];
		currentAlter[li]=absAlter[li*num_look+0];
	}

	// we calculate the upperbound[0] a little bit differently:

	double *workupperarray;
	int uppertimes=10000;
	workupperarray=new double[uppertimes];

	workupperarray=Stand_Normal(uppertimes);

	double *normalstructure;
	normalstructure=new double[2*1+1];
	normalstructure=NormalCheck(1, uppertimes, workupperarray);


	upperbound[0]=Sample_Quan(uppertimes, workupperarray, 1-alpha3[0]);
	lowerbound[0]=Sample_Quan(simul1, currentAlter, beta3[0]);

	for(li=0; li<simul1; li++) {
		if( (currentNull[li] < upperbound[0]) && (currentNull[li] > lowerbound[0]) )
			countNull[0]=countNull[0]+1;
		if( (currentAlter[li] < upperbound[0]) && (currentAlter[li] > lowerbound[0]) )
			countAlter[0]=countAlter[0]+1;
	}

	if( upperbound[0] < lowerbound[0]) {
		boundary[2*num_look-2]=1;
		boundary[2*num_look-1]=-1;
		return boundary;
	}	// The calculation of the first look accomplished.


	// the critical boundary for the rest looks:
	for(lj=1; lj<num_look; lj++) {
		
		positionNull=0;
		positionAlter=0;
		//first get currentNull and currentAlter
		for(lk=0; lk<simul1; lk++) {
			signNull=0;
			signAlter=0;
			for(lm=0; lm<lj; lm++) {
				if( (absNull[lk*num_look+lm] > upperbound[lm] ) || ( absNull[lk*num_look+lm] <lowerbound[lm]) )
					signNull=1;
				if( (absAlter[lk*num_look+lm] > upperbound[lm] ) || ( absAlter[lk*num_look+lm] <lowerbound[lm]) )
					signAlter=1;
			}

			if(signNull==0) {
				currentNull[positionNull]=absNull[lk*num_look+lj];
				positionNull=positionNull+1;
			}	

			if(signAlter==0) {
				currentAlter[positionAlter]=absAlter[lk*num_look+lj];
				positionAlter=positionAlter+1;
			}	
			
		}
			
		
		// we can get boundary now???

		alpha4[lj]=alpha3[lj]*simul1/countNull[lj-1];
		beta4[lj]=beta3[lj]*simul1/countAlter[lj-1];
		upperbound[lj]=Sample_Quan( positionNull, currentNull, 1-alpha4[lj]);
		lowerbound[lj]=Sample_Quan( positionAlter, currentAlter, beta4[lj]);

		if(upperbound[lj] < lowerbound[lj]) {
			boundary[2*num_look-2]=1;
			boundary[2*num_look-1]=-1;
			return boundary;
		}

		//now we count: after the current bound, how many left:
		for(lk=0; lk<simul1; lk++) {
			signNull=0;
			signAlter=0;
			for(lm=0; lm<=lj; lm++) {
				if( (absNull[lk*num_look+lm] > upperbound[lm] ) || ( absNull[lk*num_look+lm] <lowerbound[lm]) )
					signNull=1;
				if( (absAlter[lk*num_look+lm] > upperbound[lm] ) || ( absAlter[lk*num_look+lm] <lowerbound[lm]) )
					signAlter=1;
			}

			if(signNull==0) countNull[lj]=countNull[lj]+1;
			if(signAlter==0) countAlter[lj]=countAlter[lj]+1;
		}

	}

	return boundary;
}









// The calculation of LogRank test.
// return value is a double type Normal;
// Group One: placebo; Group Two: treatment.  

// ATTENTION: TimeGroupOne(Two)  should be sorted.
double UniSurvival::LogRank(double * TimeGroupOne, int * IndicatorGroupOne, int lengthOne,
								 double * TimeGroupTwo, int * IndicatorGroupTwo, int lengthTwo)
{
	int i, j, k, l, m, n;
	int lengthEvent=0;

	double *Time;			// Time of events
	int * GroupIndicator;	// which group the event belongs to

	int con1;
	int ii;

	// Calculate how many events we have in both groups.
	// 0 means event; 1 means censoring;
	for(i=0; i< lengthOne; i++){
		if( IndicatorGroupOne[i]==0 ) lengthEvent=lengthEvent+1;
	}
	for(j=0; j< lengthTwo; j++){
		if( IndicatorGroupTwo[j]==0 ) lengthEvent=lengthEvent+1;
	}
	
	Time=new double[lengthEvent];
	GroupIndicator=new int[lengthEvent];

	// Now we record the time of event and which group it belongs to
	i=0; j=0; k=0;

	while( ((IndicatorGroupOne[i]!=1) || (IndicatorGroupTwo[j]!=1)) && ((i<lengthOne) || (j<lengthTwo)) ) {
		if( TimeGroupOne[i] <= TimeGroupTwo[j] ) {
			Time[k]=TimeGroupOne[i];
			GroupIndicator[k]=1;       
			k=k+1; 
			i=i+1;
		}	// Record one event from group one

		if( TimeGroupTwo[j] < TimeGroupOne[i] ) {
			Time[k]=TimeGroupTwo[j];
			GroupIndicator[k]=2;
			k=k+1;
			j=j+1;
		}			
	}


	// Next we calculate the four elements in the 2*2 Table
	int * deadGroupOne;
	int * aliveGroupOne;
	int * deadGroupTwo;
	int * aliveGroupTwo;

	deadGroupOne=new int[lengthEvent];
	aliveGroupOne=new int[lengthEvent];
	deadGroupTwo=new int[lengthEvent];
	aliveGroupTwo=new int[lengthEvent];

	l=0; m=0; n=0;
	// Initialize the first elements:

	for(ii=0; ii<lengthEvent; ii++){
		deadGroupOne[ii]=0;
		deadGroupTwo[ii]=0;
	}//death is not additive

	deadGroupOne[0]=0;
	deadGroupTwo[0]=0;
	aliveGroupOne[0]=lengthOne;
	aliveGroupTwo[0]=lengthTwo;


	while( TimeGroupOne[m] == Time[0] ){
		
		if( IndicatorGroupOne[m] == 0) {
			deadGroupOne[0]=deadGroupOne[0]+1;
			aliveGroupOne[0]=aliveGroupOne[0]-1;
		}	// a death in group one

		if( IndicatorGroupOne[m] == 1) {
			deadGroupOne[0]=deadGroupOne[0];
			aliveGroupOne[0]=aliveGroupOne[0]-1;
		}	// a censoring in group one
		m=m+1;

	}

	while( TimeGroupTwo[n] == Time[0] ){

		if( IndicatorGroupTwo[n] == 0) {
			deadGroupTwo[0]=deadGroupTwo[0]+1;
			aliveGroupTwo[0]=aliveGroupTwo[0]-1;
		}	// a death in group two
		
		if( IndicatorGroupTwo[n] == 1) {
			deadGroupTwo[0]=deadGroupTwo[0];
			aliveGroupTwo[0]=aliveGroupTwo[0]-1;
		}	// a censoring in group two
		n=n+1;
	}


	// check procedure

	for( l=1; l<lengthEvent; l++) {

		aliveGroupOne[l]=aliveGroupOne[l-1];
		aliveGroupTwo[l]=aliveGroupTwo[l-1];

		while( TimeGroupOne[m] == Time[l] ){

			if( IndicatorGroupOne[m] == 0) {
				deadGroupOne[l]=deadGroupOne[l]+1;
				aliveGroupOne[l]=aliveGroupOne[l]-1;
			}	// a death in group one

			if( IndicatorGroupOne[m] == 1) {
				deadGroupOne[l]=deadGroupOne[l];
				aliveGroupOne[l]=aliveGroupOne[l]-1;
			}	// a censoring in group one

			m=m+1;
		}
	
		while( TimeGroupTwo[n] == Time[l] ){

			if( IndicatorGroupTwo[n] == 0) {
				deadGroupTwo[l]=deadGroupTwo[l]+1;
				aliveGroupTwo[l]=aliveGroupTwo[l]-1;
			}	// a death in group two

			if( IndicatorGroupTwo[n] == 1) {
				deadGroupTwo[l]=deadGroupTwo[l];
				aliveGroupTwo[l]=aliveGroupTwo[l]-1;
			}	// a censoring in group two
			
			n=n+1;
		}
	
	}

	// Now comes the calculation of test statistic
	double mean=0, variance=0, temp1, temp2, temp3, temp4, temp5;
	double testStatistic;

	for(i=0; i<lengthEvent; i++) {
		temp1=deadGroupOne[i]+aliveGroupOne[i];
		temp2=deadGroupOne[i]+deadGroupTwo[i];
		temp3=deadGroupOne[i]+deadGroupTwo[i]+aliveGroupOne[i]+aliveGroupTwo[i];
		temp4=deadGroupTwo[i]+aliveGroupTwo[i];
		temp5=aliveGroupOne[i]+aliveGroupTwo[i];

		cin>>con1;
		if(temp3!=0) {
			mean=mean+deadGroupOne[i]- (temp1*temp2/temp3);
			if( temp3>1) 
				variance=variance+temp1*temp2*temp4*temp5/(temp3*temp3*(temp3-1));
			else 
				variance=variance;
		}
		else {
			mean=mean;
			variance=variance;
		}


	}

	testStatistic=mean/sqrt(variance);

	delete  deadGroupOne;
	delete  deadGroupTwo;
	delete  aliveGroupOne;
	delete  aliveGroupTwo;

	return testStatistic;

}
				







//new version of logrank test statistic

double UniSurvival::LogRankA(double * TimeGroupOne, int * IndicatorGroupOne, int lengthOne,
								 double * TimeGroupTwo, int * IndicatorGroupTwo, int lengthTwo, 
									int dead1, int dead2)
{
	int i, j, k, l, m, n;
	int lengthEvent=0;

	double *Time;			// Time of events
	int * GroupIndicator;	// which group the event belongs to

	int con1;
	int ii;

	// check the input values:

	// Calculate how many events we have in both groups.
	// 0 means event; 1 means censoring;
	for(i=0; i< lengthOne; i++){
		if( IndicatorGroupOne[i]==0 ) lengthEvent=lengthEvent+1;
	}
	for(j=0; j< lengthTwo; j++){
		if( IndicatorGroupTwo[j]==0 ) lengthEvent=lengthEvent+1;
	}
	

	Time=new double[lengthEvent];
	GroupIndicator=new int[lengthEvent];


	// Time and Indicator check:

	// Now we record the time of event and which group it belongs to
	i=0; j=0; k=0;
	
	// the new code for recording the time of event and which group it belongs to:
	int eventLengthOne=0, eventLengthTwo=0;
	
	for(i=0; i<lengthOne; i++) {
		if( IndicatorGroupOne[i]==0 ) eventLengthOne=eventLengthOne+1;
	}
	for(i=0; i<lengthTwo; i++) {
		if(IndicatorGroupTwo[i]==0) eventLengthTwo=eventLengthTwo+1;
	}

	i=0; j=0; k=0;
	while( IndicatorGroupOne[i]==0 ) {
		Time[k]=TimeGroupOne[i];
		i=i+1; 
		k=k+1;
	}
	while( IndicatorGroupTwo[j]==0 ) {
		Time[k]=TimeGroupTwo[j];
		j=j+1; 
		k=k+1;
	}

	mySort(Time, lengthEvent);

	i=0; j=0; k=0;
	for(k=0; k<lengthEvent; k++){
		if( Time[k]==TimeGroupOne[i] ) {
			GroupIndicator[k]=1;
			i=i+1;
		}

		else if( Time[k]==TimeGroupTwo[j] ) {
			GroupIndicator[k]=2;
			j=j+1;
		}
	}

	// Next we calculate the four elements in the 2*2 Table
	int * deadGroupOne;
	int * aliveGroupOne;
	int * deadGroupTwo;
	int * aliveGroupTwo;

	deadGroupOne=new int[lengthEvent];
	aliveGroupOne=new int[lengthEvent];
	deadGroupTwo=new int[lengthEvent];
	aliveGroupTwo=new int[lengthEvent];
	
	l=0; m=0; n=0;
	// Initialize the first elements:

	for(ii=0; ii<lengthEvent; ii++){
		deadGroupOne[ii]=0;
		deadGroupTwo[ii]=0;
	}//death is not additive

	deadGroupOne[0]=0;
	deadGroupTwo[0]=0;
//	aliveGroupOne[0]=lengthOne;
//	aliveGroupTwo[0]=lengthTwo;

	aliveGroupOne[0]=dead1;
	aliveGroupTwo[0]=dead2;

	while( TimeGroupOne[m] == Time[0] ){
		
		if( IndicatorGroupOne[m] == 0) {
			deadGroupOne[0]=deadGroupOne[0]+1;
			aliveGroupOne[0]=aliveGroupOne[0]-1;
		}	// a death in group one

		if( IndicatorGroupOne[m] == 1) {
			deadGroupOne[0]=deadGroupOne[0];
			aliveGroupOne[0]=aliveGroupOne[0]-1;
		}	// a censoring in group one
		m=m+1;

	}

	while( TimeGroupTwo[n] == Time[0] ){

		if( IndicatorGroupTwo[n] == 0) {
			deadGroupTwo[0]=deadGroupTwo[0]+1;
			aliveGroupTwo[0]=aliveGroupTwo[0]-1;
		}	// a death in group two
		
		if( IndicatorGroupTwo[n] == 1) {
			deadGroupTwo[0]=deadGroupTwo[0];
			aliveGroupTwo[0]=aliveGroupTwo[0]-1;
		}	// a censoring in group two
		n=n+1;

	}


	for( l=1; l<lengthEvent; l++) {

		aliveGroupOne[l]=aliveGroupOne[l-1];
		aliveGroupTwo[l]=aliveGroupTwo[l-1];

		while( TimeGroupOne[m] == Time[l] ){

			if( IndicatorGroupOne[m] == 0) {
				deadGroupOne[l]=deadGroupOne[l]+1;
				aliveGroupOne[l]=aliveGroupOne[l]-1;
			}	// a death in group one

			if( IndicatorGroupOne[m] == 1) {
				deadGroupOne[l]=deadGroupOne[l];
				aliveGroupOne[l]=aliveGroupOne[l]-1;
			}	// a censoring in group one

			m=m+1;
		}
	

		while( TimeGroupTwo[n] == Time[l] ){

			if( IndicatorGroupTwo[n] == 0) {
				deadGroupTwo[l]=deadGroupTwo[l]+1;
				aliveGroupTwo[l]=aliveGroupTwo[l]-1;
			}	// a death in group two

			if( IndicatorGroupTwo[n] == 1) {
				deadGroupTwo[l]=deadGroupTwo[l];
				aliveGroupTwo[l]=aliveGroupTwo[l]-1;
			}	// a censoring in group two
			
			n=n+1;
		}
	}


	// Now comes the calculation of test statistic
	double mean=0, variance=0, temp1, temp2, temp3, temp4, temp5;
	double testStatistic;

	for(i=0; i<lengthEvent; i++) {
		temp1=deadGroupOne[i]+aliveGroupOne[i];
		temp2=deadGroupOne[i]+deadGroupTwo[i];
		temp3=deadGroupOne[i]+deadGroupTwo[i]+aliveGroupOne[i]+aliveGroupTwo[i];
		temp4=deadGroupTwo[i]+aliveGroupTwo[i];
		temp5=aliveGroupOne[i]+aliveGroupTwo[i];

		if(temp3!=0) {
			mean=mean+deadGroupOne[i]- (temp1*temp2/temp3);
			if( temp3>1) 
				variance=variance+temp1*temp2*temp4*temp5/(temp3*temp3*(temp3-1));
			else 
				variance=variance;
		}
		else {
			mean=mean;
			variance=variance;
		}


	}

	testStatistic=mean/sqrt(variance);

	delete  deadGroupOne;
	delete  deadGroupTwo;
	delete  aliveGroupOne;
	delete  aliveGroupTwo;

	return testStatistic;

}




// Standard Normal Generator:
double* UniSurvival::Stand_Normal(int i)   //yu endpoint wu guan
{
  double *p, *workarray;
  double r, theta;
  double mean=0.0;
  double var=0.0;

  int con1;

  int j;
  int n=0; // the count
  p=new double[i];
  workarray= new double[i];
  int seed1= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
  long* idum1=new long(seed1);
  int seed2= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
  long* idum2=new long(seed2);

  //WE USE TIME TO CONTROL THE RANDOM NUMBER

  while(n<i){
	workarray[n]=ran1(idum1); 
	workarray[n+1]=ran1(idum2); 

	if(workarray[n]>0){
		r=sqrt(-2*log(workarray[n]));
		theta=2*Pi*workarray[n+1];
		p[n]=r*cos(theta);
		p[n+1]=r*sin(theta);
		n=n+2;
		}  
	} // We here avoid the extremely small case which will make the NA case

  double *check;
  check=new double[2+1*1];
  check=NormalCheck(1, i, workarray);

  //standardize to guaranttee the mean and variance.
  return p;
}




//The old version of Stand_Normal:

double* UniSurvival::OLDStandNormal(int i)   //yu endpoint wu guan
{
  double *p, *workarray;
  double r, theta;
  int n=0; // the count
  p=new double[i];
  workarray= new double[i];

  //WE USE TIME TO CONTROL THE RANDOM NUMBER
  srand ((unsigned)time(NULL));

	cout<<"here in the OLD Stand Normal"<<endl;	
	cout<<i<<endl;

  while(n<i){
	workarray[n]=( (double) ( rand() % 2000) ) / 2000.0  ; 
	workarray[n+1]=( (double) ( rand() % 2000) ) / 2000.0  ; 
    
	cout<<workarray[n]<<endl;

	if(workarray[n]>0.00001){
		r=sqrt(-2*log(workarray[n]));
		theta=2*Pi*workarray[n+1];
		p[n]=r*cos(theta);
		p[n+1]=r*sin(theta);
		n=n+2;
		}  
	} // We here avoid the extremely small case which will make the NA case

  delete [] workarray;

  return p;
}





// The exponential generator
double* UniSurvival::ExpGenerator(int size, double lambda1)
{
  double * work_array; 
  double * exp_array;
  int i=0;
  int con1;
  int seed;

  seed= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
  work_array=new double[size];
  exp_array=new double[size];


  long* idum=new long(seed);
  
  while(i<size){
	  work_array[i]=ran1(idum);
	  if(work_array[i] > 0) {
		  exp_array[i]=-(1/lambda1)*log(work_array[i]);
		  i=i+1;
	  }
  }

  return exp_array;
}




// we check the exp generator
void UniSurvival::checkExpGenerator()
{
	int i,j;
	int times=50000;
	int length=118;
	double lambda=0.1733;
	double *meanA1, *varA1;

	meanA1=new double[times];
	varA1=new double[times];

	double *work1;
	work1=new double[length];

	for(i=0; i<times; i++){
		meanA1[i]=0;
		varA1[i]=0;
		work1=ExpGenerator(length, lambda);
		for(j=0; j<length; j++) {
			meanA1[i]=meanA1[i]+work1[j];
		}
		meanA1[i]=meanA1[i]/length;
		for(j=0; j<length; j++){
			varA1[i]=varA1[i]+(work1[j]-meanA1[i])*(work1[j]-meanA1[i]);
		}
		varA1[i]=varA1[i]/length;
	}
	
	double mean1=0, mean2=0;
	double var1=0, var2=0;
	for(i=0; i<times; i++)
		mean1=mean1+meanA1[i];
	mean1=mean1/times;

	for(i=0; i<times; i++)
		var1=var1+(meanA1[i]-mean1)*(meanA1[i]-mean1);
	var1=var1/times;

	for(i=0; i<times; i++)
		mean2=mean2+varA1[i];
	mean2=mean2/times;

	for(i=0; i<times; i++)
		var2=var2+(varA1[i]-mean2)*(varA1[i]-mean2);
	var2=var2/times;

}


// The normal generator with a certain variance structure:
// covariance: size1*size1
double * UniSurvival::NormalGenerator(int size1, int size2, double * covariance)
{
	int i, j, k;
	double * workarray;
	double *v3sq;

	workarray=new double[size1*size2];

	v3sq=new double[size1*size1];

	workarray=Stand_Normal(size1*size2);
	v3sq=sqrt_matrix(size1, covariance);

	// the 1st check in the NormalGenerator:
	double *transpose;
	transpose=new double[size1*size1];
	for(i=0; i<size1; i++){
		for(j=0; j<size1; j++) {
			transpose[i*size1+j]=v3sq[j*size1+i];
		}
	}

	double *temp_work2=new double[size1*size2];
	double *worktranspose;
	worktranspose=new double[size1*size2];

	for (i=0;i<size1*size2; i++){
		temp_work2[i]=workarray[i];
		worktranspose[i]=0.0;
	}


	for(i=0; i<size1; i++) {
		for(j=0; j<size2; j++) {
			for(k=0; k<size1; k++) {
				worktranspose[i*size2+j]=worktranspose[i*size2+j]+transpose[i*size1+k]*temp_work2[k*size2+j];
			}
		}
	}
	// the second check in NormalGenerator:

	for(i=0; i<size2; i++){
		for(j=0; j<size1; j++) {
			temp_work2[i*size1+j]=worktranspose[j*size2+i];
		}
	}

	return temp_work2;

}





// The square root of a matrix by LP
double *UniSurvival::sqrt_matrix(int size, double *A)  // Transpose(B)*(B) = A , B is an upper triangular matrix,
{
	double *B = new double[size*size];
	int i=0, j=0;

	for(i=0; i<size; i++){			//initialize
		for(j=0; j<size; j++){
			B[i*size+j] = 0;
		}
	}
	double temp_Bii2=0, temp_Bij=0;

	int p=0, q=0;
	for(i=0; i<size; i++){
		temp_Bii2 = A[i*size+i];
		for(p=0; p<i; p++){
			temp_Bii2 -= pow(B[p*size+i],2);
		}
		B[i*size+i] = pow(temp_Bii2, 0.5);

		for(j=i+1; j<size; j++){
			temp_Bij = A[i*size+j];
			for(q=0; q<i; q++){
				temp_Bij -= B[q*size+i]*B[q*size+j];
			}
			B[i*size+j]=temp_Bij/B[i*size+i];
		}
	}

	return B;
}




double *UniSurvival::NormalCheck(int size1, int size2, double * checkarray)
{
	double *structure;
	double *meanA1, *varA1, *corrA1;
	structure=new double[2*size1+size1*size1];
	meanA1=new double[size1];
	varA1=new double[size1];
	corrA1=new double[size1*size1];

	int i, j, k;
	for(i=0; i<size1; i++){
		meanA1[i]=0;
		for(j=0; j<size2; j++){
			meanA1[i]=meanA1[i]+checkarray[j*size1+i];
		}
		meanA1[i]=meanA1[i]/size2;
	}
	for(i=0; i<size1; i++) {
		varA1[i]=0;
		for(j=0; j<size2; j++) {
			varA1[i]=varA1[i]+(checkarray[j*size1+i]-meanA1[i])*(checkarray[j*size1+i]-meanA1[i]);
		}
		varA1[i]=varA1[i]/size2;
	}
	for(i=0; i<size1; i++){
		for(j=0; j<size1; j++){
			corrA1[i*size1+j]=0;
			for(k=0; k<size2; k++){
				corrA1[i*size1+j]=corrA1[i*size1+j]+(checkarray[k*size1+i]-meanA1[i])*(checkarray[k*size1+j]-meanA1[j]);
			}
			corrA1[i*size1+j]=corrA1[i*size1+j]/size2;
			corrA1[i*size1+j]=corrA1[i*size1+j]/sqrt(varA1[i]*varA1[j]);
		}
	}

	for(i=0; i<size1; i++){
		structure[i]=meanA1[i];
		structure[i+size1]=varA1[i];
	}
	for(i=0; i<size1*size1; i++)
		structure[2*size1+i]=corrA1[i];
	
	return structure;
}







// alpha and beta calculation:
double* UniSurvival::alpha_beta1(double totalAlphaBeta)
{
	double *information3;
	information3=new double[num_look];

	int i;
	for(i=0; i<num_look; i++)
		information3[i]=inform_time[i]/inform_time[num_look-1];

	double *alphareturn;
	double *alphatemp;
	alphareturn=new double[num_look];
	alphatemp=new double[num_look];

	for(i=0; i< num_look; i ++){
		alphareturn[i]=totalAlphaBeta*(1-exp(4*information3[i]))/(1-exp(4));
	}

	alphatemp[0]=alphareturn[0];
	for(i=1; i<num_look; i++)
		alphatemp[i]=alphareturn[i]-alphareturn[i-1];

	return alphatemp;
}

// For spending_num=2;

double *UniSurvival::alpha_beta2(double totalAlphaBeta)
{
	double *alphareturn;
	double *alphatemp;
	alphareturn=new double[num_look];
	alphatemp=new double[num_look];

	int i;

	for(i=0; i<num_look; i++) {
		alphareturn[i]=totalAlphaBeta*inform_time[i]/inform_time[num_look-1];
	}

	alphatemp[0]=alphareturn[0];
	for(i=1; i<num_look; i++) {
		alphatemp[i]=alphareturn[i]-alphareturn[i-1];
	}

	return alphatemp;
}

// For spending_num=3, 4..... (God Save Poor)

double *UniSurvival::alpha_beta3(double totalAlphaBeta)
{
	double *alphareturn;
	double *alphatemp;
	alphareturn=new double[num_look];
	alphatemp=new double[num_look];

	int i;

	for(i=0; i< num_look; i++) {
		alphareturn[i]=totalAlphaBeta*inform_time[i]*inform_time[i]/inform_time[num_look-1];
	}
	alphatemp[0]=alphareturn[0];
	for(i=1; i<num_look; i++) {
		alphatemp[i]=alphareturn[i]-alphareturn[i-1];
	}

	return alphatemp;
}




// calculation of sample quantile

double UniSurvival::Sample_Quan(int size, double *array1, double percentage)
{
  double *p;
  int flag=1; // if flag=1, need to do more work
  double tmp, score;
  int count=0, position;
  p=new double[size];  

  p=array1;

  while (flag!=0)
    {
      flag=0;
      for(int i=0; i<size-1-count; i++){
		if(p[i]>p[i+1]){
		tmp=p[i];
		p[i]=p[i+1];
		p[i+1]=tmp;
		flag=1;
		}
      }
      count++;
    }
	
  position=(int) (percentage*(size-1) );

  score=array1[position];
	
  int i;

  return score;            // Return value is the percentile
}



float UniSurvival::ran1(long *idum)
{	int j;
	long k;
	static long iy=0;
	static long iv[NTAB];
	float temp;

	if (*idum <= 0 || !iy) {		//Initialize.
		if (-(*idum) < 1) *idum=1;	//Be sure to prevent idum = 0.
		else *idum = -(*idum);
		for (j=NTAB+7;j>=0;j--) {	//Load the shu.e table (after 8 warm-ups).
			k=(*idum)/IQ;
			*idum=IA*(*idum-k*IQ)-IR*k;
			if (*idum < 0) *idum += IM;
			if (j < NTAB) iv[j] = *idum;
		}
		iy=iv[0];
	}

	k=(*idum)/IQ;					//Start here when not initializing.
	*idum=IA*(*idum-k*IQ)-IR*k;		//Compute idum=(IA*idum) % IM without over-ows by Schrage's method. 
	if (*idum < 0)	*idum += IM;
	j=iy/NDIV;						//Will be in the range 0..NTAB-1.
	iy=iv[j];						//Output previously stored value and refill the shuffle table. 
	iv[j] = *idum;

	if ((temp=AM*iy) > RNMX) 
		return RNMX;				//Because users don't expect endpoint values.
	else 
		return temp;
}











//
// The New Approach to Calculate for the Survival Case:
//

// For the calculation of sample size with Gaussian Approxiamation, we only need to create
// a UniNormal type variable:

EndNormal * SurNormal1;
void UniSurvival::SizeGaussian()
{
	SurNormal1=new EndNormal;

	int i, j;
	int con1;

	// Initialize the SurNormal1:
	SurNormal1->order=1;
	SurNormal1->num_look=num_look;
	SurNormal1->num_simul=num_simul;
	SurNormal1->look_simul=num_simul/num_look;
	
	double proportion;

	proportion=DeathProp(5000);

	prop=proportion;

	SurNormal1->mean_Null=0;
	SurNormal1->mean_Alter=absd(log(lambdaAlter/lambdaNull) / log(2.7182818284))*sqrt(proportion);
//	cout<<"SurNormal1->mean_Alter"<<"\t"<<SurNormal1->mean_Alter<<endl;
	SurNormal1->var_Null=1;
	SurNormal1->var_Alter=1;

	for(i=0; i<num_look; i++)
		SurNormal1->inform_time[i]=inform_time[i] / inform_time[num_look-1];

	SurNormal1->overall_alpha=alpha;
	SurNormal1->overall_beta=beta;

	SurNormal1->spending_num=alphaSpend;

	SurNormal1->sample_size=SurNormal1->one_stage_normal();
	
	SurNormal1->SizeAdjust();
	
//	samplesize=int (SurNormal1->sample_size*1.0/proportion);
	samplesize=int (SurNormal1->sample_size*1.0);

	for(i=0; i<num_look; i++){
		alpha_spending[i]=SurNormal1->alpha[i];
		beta_spending[i]=SurNormal1->beta[i];
	}

	for(i=0; i<num_look; i++) {
		upperbound[i]=SurNormal1->upper_bound[i];
		lowerbound[i]=SurNormal1->lower_bound[i];
	}
	for(i=0; i<2*num_look; i++) {
		boundary[i]=SurNormal1->boundary[i];
	}

}




double UniSurvival::DeathProp( int sim)
{
	int i, j;
	int count1=0, count2=0;
	double *entry1, *entry2;
	double *death1, *death2;
	entry1=new double[sim];
	entry2=new double[sim];
	death1=new double[sim];
	death2=new double[sim];

	srand ((unsigned)time(NULL));
	int seed= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
	long *idum=new long(seed);

	for(i=0; i<sim; i++){
		entry1[i]=entry*ran1(idum);
		entry2[i]=entry*ran1(idum);
	}

	death1=ExpGenerator(sim, lambdaNull);
	death2=ExpGenerator(sim, lambdaAlter);

	for(i=0; i<sim; i++) {
		if( (entry1[i]+death1[i]) < (entry+followup) )
			count1=count1+1;
		if( (entry2[i]+death2[i]) < (entry+followup) )
			count2=count2+1;
	}

	double prop;
	prop= (1.0*(count1+count2))/(2.0*sim);

	return prop;

}



