
// Copyright Shuangge Ma, january 2002

#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <string.h>

#define Pi 3.1415926
#define LIMIT_N_LOOK 10
#define QuantileSim  2000 //the number of simulation we need for the calculation of Normal quantile.

class UniSurvival 
{
public:
	UniSurvival();

	int order;				// the 1st or the 2nd endpoint
	char *type;
	char data_type;			// type of data
	int num_look;			// num of look
	int num_simul;         // number of simulations
	int looksimul;

	int rule_decision;		// decision: hard--0 or soft--1

	double prop;		// proportion of death

	double alpha, beta;		// type I and II error
	double * alpha_spending;
	double * beta_spending;
	double Bi_Alpha;
	double Bi_Beta;
	double corr_ph;

	double * inform_time;	// The information spending
	double * calender;		// The real corresponding calender time 
	
	int alphaSpend, betaSpend;	// Alpha and Beta spending number

	int *ctrl_ind;

	double lambdaNull, lambdaAlter;	// The hazard rate under Null and Alter
	double entry;		// patient enter in time [0, entry];
	double followup;	// The follow up time [0, entry+fowllowup]

	double lambdadrop;	// The hazard rate of dropping for Null and Alter
	
	int samplesize;     // The minimal sample size we need

	double *upperbound;		// The boundaries for the logrank test statistics 
	double *lowerbound;		// corresponding to the minimal required size
	double *boundary;


	int getLooksimul();

	int IniSizeEstimate();
	// The initial sample size estimate

	double LogRank(double *, int *, int, double *, int *, int);
	// The calculation of logrank test statistic

	double LogRankA(double *, int *, int, double *, int *, int, int, int);
	// The new calculation of logrank test statistic.

	double *ExpGenerator(int ,double);
	// The exponential generator		

	double *ExpNormalizer(int, double, double*);
	// Normalize the Exp Generator:

	void checkExpGenerator();
	// check the exp generator:

	double *Stand_Normal(int);
	// Standard Normal generator:
	
	double *NormalGenerator(int, int, double *);
	// The generator of Normal with a certain covariance structure:

	double *ParameterEstimate(int, int);
	// Estimate the mean, var and corr of the Normal dist. logrank test statistics

	double *BoundCalculation(int, double *, double *);
	// The calculation of boundary.
	// Input: row number of Null & Alter, Null & Alter (num_look*simul1);

	double *sqrt_matrix(int, double *);
	//square root of a matrix:

	double *NormalCheck(int, int, double *);
	// the check of Normal.

	int SizeCalculation(); 

	// The alpha and beta calculations:
	double *alpha_beta1(double);

	double *alpha_beta2(double);

	double *alpha_beta3(double);

	double Sample_Quan(int, double *, double);
	// calculation of sample quantile

	float ran1(long*);

	double *OLDStandNormal(int);


//
//	The new approach: Gaussian Approxiamation:
//

	int Choice();

	void SizeGaussian();

	double *GaussianBoundary(int );

	double *GaussianGenerator1();

	double *GaussianGenerator2(int, double*);

	double DeathProp(int);
};


